DEFINE VARIABLE iCntnrs AS INTEGER NO-UNDO.

DEFINE BUFFER b-ca-u_voyage_container FOR ca-u_voyage_container.

ON WRITE OF ca-u_voyage_container OVERRIDE DO:
END.

cntr:
FOR EACH ca-u_shipment_item_container NO-LOCK:
  FIND FIRST ca-u_shipment WHERE
        ca-u_shipment.companycode EQ ca-u_shipment_item_container.companycode AND
        ca-u_shipment.shipment_seqnr EQ ca-u_shipment_item_container.shipment_seqnr NO-LOCK NO-ERROR.
  IF NOT AVAILABLE ca-u_shipment THEN NEXT cntr.

  FIND ca-u_voyage_container WHERE
       ca-u_voyage_container.companycode     EQ ca-u_shipment_item_container.companycode AND
       ca-u_voyage_container.vesselnr        EQ ca-u_shipment.vesselNr AND
       ca-u_voyage_container.pol_portcode    EQ "" AND
       ca-u_voyage_container.pod_portcode    EQ "" AND
       ca-u_voyage_container.inward-outward  EQ 'o' AND
       ca-u_voyage_container.containerprefix EQ ca-u_shipment_item_container.containerprefix AND
       ca-u_voyage_container.containernr     EQ ca-u_shipment_item_container.containernr NO-LOCK NO-ERROR.

  IF NOT AVAILABLE ca-u_voyage_container THEN NEXT cntr.

  IF AVAILABLE ca-u_voyage_container THEN RUN updateContainer.

END.

MESSAGE iCntnrs "Done." VIEW-AS ALERT-BOX.

/* **********************  Internal Procedures  *********************** */

PROCEDURE updateContainer:

  DO TRANSACTION:
  FIND FIRST b-ca-u_voyage_container WHERE
             b-ca-u_voyage_container.companycode     EQ ca-u_shipment_item_container.companycode AND
             b-ca-u_voyage_container.vesselnr        EQ ca-u_shipment.vesselNr AND
             b-ca-u_voyage_container.pol_portcode    EQ "" AND
             b-ca-u_voyage_container.pod_portcode    EQ "" AND
             b-ca-u_voyage_container.inward-outward  EQ 'o' AND
             b-ca-u_voyage_container.containerprefix EQ ca-u_shipment_item_container.containerprefix AND
             b-ca-u_voyage_container.containernr     EQ ca-u_shipment_item_container.containernr EXCLUSIVE-LOCK.

  ASSIGN b-ca-u_voyage_container.pol_portcode = ca-u_shipment.pol_portcode
         b-ca-u_voyage_container.pod_portcode = ca-u_shipment.pod_portcode
         iCntnrs = iCntnrs + 1.
  END.

END PROCEDURE.


